#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "util.h"

#define CHECK_AND_RETURN(_ptr)							\
	if (_ptr == NULL) {									\
		fprintf(stderr, "Memory allocation failed.\n"); \
		exit(2);										\
	}													\
	return _ptr;

void *lf_malloc(size_t size) {
	void *ptr = malloc(size);
	CHECK_AND_RETURN(ptr);
}

void *lf_realloc(void *ptr, size_t size) {
	void *new_ptr = realloc(ptr, size);
	CHECK_AND_RETURN(new_ptr);
}
void *lf_calloc(size_t count, size_t size) {
	void *ptr = calloc(count, size);
	CHECK_AND_RETURN(ptr);
}
char *lf_strdup(const char *s) {
	char *str = strdup(s);
	CHECK_AND_RETURN(str);
}
